


/* Pre: el paràmetre implícit no conté cap estudiant amb el dni d'est */
void Cjt_estudiants::afegir_estudiant(const Estudiant &est)
{
//Pre: vest està ordenat  i vest = V
  int dni=est.consultar_DNI();
  int i = nest-1;

//Inv: -1=< i =< nest-1 
//     per tota posició p en [i+1..nest-1] tenim vest[p+1]=V[p] 
//     i dni és menor que el DNI de V[p];
  while (i>=0 and dni < vest[i].consultar_DNI()) {
    vest[i+1]=vest[i];
    --i;
  }
//Postw: per tota posició p en [0..i] tenim vest[p]=V[p] i dni és més
//gran o igual que el DNI de V[p]; i per tota posició p en [i+1..nest-1]
//tenim vest[p+1]=V[p] i dni és menor que el DNI de V[p];

  vest[i+1] = est;
  ++nest;
}
  /* Post: s'ha afegit l'estudiant est al paràmetre implícit */


/*

1) Inicialitzacions:

No hi ha cap posició entre nest i nest-1, per tant l'invariant es
satisfà.

2) Cos del bucle:

De l'invariant i la condició del bucle tenim que:
per tota posició p en [i+1..nest-1] tenim vest[p+1]=V[p] i dni és
menor que el DNI de V[p]; i >=0 i dni és menor que el dni de
vest[i]=V[i].  

Per tant si posem vest[i+1]=vest[i]=V[i], tenim que per tota posició p
en [i..nest-1] tenim vest[p+1]=V[p] i dni és menor que el DNI de V[p],
ja que vest[i+1]=V[i] i dni és menor que el DNI de V[i]; si finalment
decrementem i tornem a tenir l'invariant.

3) Condició de sortida

Sortim si i<0 o si dni és més gran o igual que el DNI de  vest[i]

Si i<0, per l'invariant tenim que i=-1 i llavors per tota posició
entre 0 i nest-1 vest[p+1]=V[p] i dni és menor que el DNI de V[p], per
tant Postw es compleix.

Si (i>=0) i dni és més gran o igual que el DNI de vest[i], com que V
està ordenat, per totes les posicions p en [0..i] tenim que
vest[p]=V[p] i dni és més gran o igual que el DNI de V[p]. Això,
juntament amb l'invariant, ens dona Postw

4) Acabament

Decreix i;

*/
