#include "utils.PRO2"
#include "Estudiant.hpp"
#include "vect_est_io.cpp"


inline double arrodonir(double r)
 /* Pre: cert */
{  
  return int(10.*(r + 0.05)) / 10.0;
} /* Post: El resultat s el valor de original de r arrodonit a 
    la dcima ms propera (i ms gran si hi ha empat) */



/* Pre: vest = V */
void arrodonir_notes(vector<Estudiant> &vest)
{
  int i=0; 

// i <= vest.size()
// vest[0..i-1] t els estudiants de V[0..i-1] amb la nota arrodonida

  while (i<vest.size()) {
    if (vest[i].te_nota()) {
      double aux = arrodonir(vest[i].consultar_nota());
      vest[i].modificar_nota(aux);
    }	
    ++i;
  }
}
/* Post: vest t els estudiants de V amb la nota arrodonida */


/* Justificaci:

1) Inicialitzacions:

Com que en [0..-1] no hi ha cap posici l'invariant es satisf.

2) Cos del bucle:

Per l'invariant tenim que vest[0..i-1] t els estudiants de V[0..i-1]
amb la nota arrodonida. Si vest[i] no t nota llavors la nota ja est
arrodonida, sino modifiquem la nota de vest[i] amb la nota arrodonida.
Per tant, en els dos casos la vest[i] t l'estudiant de V[i] amb la
nota arrodonida. Com que vest[0..i] t els estudiants de V[0..i] amb
la nota arrodonida, al incrementar i tornem a satisfer l'invariant.

3) Condici de sortida:

de l'invariant i que i=vest.size()=V.size(), tenim que
vest[0..vest.size()-1] t els estudiants de V[0..V.size()-1] amb la
nota arrodonida, s a dir vest t els estudiants de V amb la nota
arrodonida.

4) Acabament:

Decreix la distncia entre i i el final del vector, s a dir vest.size()-i

 */

int main()
{
  Estudiant est;
  vector < Estudiant > v;
  leerVector(v);
  cout << "Vector antes del calculo" << endl;
  escribirVector(v,v.size());
  
  arrodonir_notes(v);
 
  cout << "Vector  despues de redondear" << endl;
  escribirVector(v,v.size());
 
  
   
}

